Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2678)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2680)
@@ -1057,5 +1057,5 @@
 
 	  string ktbFilename = internKdTree;
-	  int l = ktbFilename.length();
+	  int l = (int)ktbFilename.length();
 	  ktbFilename[l-1] = 't';
 	  ktbFilename[l-2] = 'b';
@@ -1471,11 +1471,7 @@
 	
   if (renderer && renderer->mPvsStatFrames) {
-	//	emit EvalPvsStat();
-	//	QMutex mutex;
-	//	mutex.lock();
-	//	renderer->mRenderingFinished.wait(&mutex);
-	//	mutex.unlock();
-
-	if (!mViewCellsManager->GetViewCellPointsList()->empty()) {
+	
+	if (!mViewCellsManager->GetViewCellPointsList()->empty()) 
+	{
 	  
 	  ViewCellPointsList *vcPoints = mViewCellsManager->GetViewCellPointsList();
@@ -1491,5 +1487,4 @@
 
 		SimpleRayContainer::const_iterator rit = vp->second.begin(), rit_end = vp->second.end();
-
 		for (; rit!=rit_end; ++rit)
 		  viewPoints.push_back(*rit);
@@ -1501,8 +1496,9 @@
 	  }
 
-	  cerr << "evaluating list of " << viewPoints.size() << " pts" << endl;
+	  cout << "evaluating list of " << viewPoints.size() << " pts" << endl;
 	  renderer->EvalPvsStat(viewPoints);
 	} else
 	{
+		cout << "evaluating random points" << endl;
 	  renderer->EvalPvsStat();
 	}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj	(revision 2679)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtInterface05.vcproj	(revision 2680)
@@ -18,6 +18,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
+			OutputDirectory="$(SolutionDir)\Preprocessing\lib05\$(ConfigurationName)"
+			IntermediateDirectory="$(SolutionDir)\Preprocessing\obj05\$(ConfigurationName)"
 			ConfigurationType="4"
 			CharacterSet="1"
@@ -41,5 +41,6 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				PreprocessorDefinitions="WIN32;_DEBUG;_LIB"
+				AdditionalIncludeDirectories="..\src;..\..\src\;..\..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(QTDIR)\include\QtOpenGL&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(CG_INC_PATH)&quot;;&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces-c_2_8_0\include&quot;"
+				PreprocessorDefinitions="WIN32;_DEBUG;_LIB;GTP_INTERNAL;USE_QT;USE_VERBOSE_PVS;USE_CG"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/GtpVisibility05.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/GtpVisibility05.vcproj	(revision 2676)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/GtpVisibility05.vcproj	(revision 2680)
@@ -17,7 +17,7 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
-			ConfigurationType="1"
+			OutputDirectory="$(SolutionDir)\Preprocessing\lib05\$(ConfigurationName)"
+			IntermediateDirectory="$(SolutionDir)\Preprocessing\obj05\$(ConfigurationName)"
+			ConfigurationType="4"
 			CharacterSet="2"
 			>
@@ -40,6 +40,6 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;Timer"
-				PreprocessorDefinitions="WIN32;DEBUG;_CONSOLE;NO_QT;USE_VERBOSE_PVS"
+				AdditionalIncludeDirectories="..\src;Timer;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces-c_2_8_0\include&quot;;..\..\..\..\..\..\NonGTP\Boost;..\src\havran;..\MultiLevelRayTracing;&quot;$(CG_INC_PATH)&quot;"
+				PreprocessorDefinitions="WIN32;DEBUG;_CONSOLE;USE_VERBOSE_PVS;USE_QT;GTP_INTERNAL;USE_CG"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -59,9 +59,5 @@
 			/>
 			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="xerces-c_2.lib glew32.lib zdll.lib zziplib.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib Preprocessor.lib"
-				AdditionalLibraryDirectories="..\src\GL;..\lib\debug;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib"
-				GenerateDebugInformation="true"
-				TargetMachine="1"
+				Name="VCLibrarianTool"
 			/>
 			<Tool
@@ -69,7 +65,4 @@
 			/>
 			<Tool
-				Name="VCManifestTool"
-			/>
-			<Tool
 				Name="VCXDCMakeTool"
 			/>
@@ -79,10 +72,4 @@
 			<Tool
 				Name="VCFxCopTool"
-			/>
-			<Tool
-				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2679)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 2680)
@@ -118,6 +118,7 @@
 		                                      mDetectEmptyViewSpace);
 
-	//mSnapErrorFrames = false;
-	mSnapErrorFrames = true;
+	mSnapErrorFrames = false;
+	//mSnapErrorFrames = true;
+
 	mSnapPrefix = "snap/";
 	mUseForcedColors = false;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj	(revision 2677)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor05.vcproj	(revision 2680)
@@ -17,6 +17,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="..\bin\Debug"
-			IntermediateDirectory="..\obj\Debug"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj05\$(ConfigurationName)"
 			ConfigurationType="1"
 			InheritedPropertySheets="$(VCInstallDir)VCProjectDefaults\UpgradeFromVC71.vsprops"
@@ -41,6 +41,6 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\src\sparsehash\src\"
-				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;NO_QT"
+				AdditionalIncludeDirectories="..\src;..\include;..\..\..\..\..\..\NonGTP\Boost;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(QTDIR)\include\QtOpenGl&quot;;&quot;$(QTDIR)\include\Qt&quot;;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include&quot;;QtInterface;..\src\sparsehash\src\;..\src\ootl\src\include\ootl;..\src\ootl\src\include\ootl\sandbox;$(NOINHERIT)"
+				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;GTP_INTERNAL;USE_QT;USE_CG;USE_VERBOSE_PVS"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -63,8 +63,8 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="xerces-c_2D.lib zdll.lib zziplibd.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib Preprocessor.lib glew32.lib"
-				OutputFile="$(OutDir)/Preprocessor.exe"
+				AdditionalDependencies="xerces-c_2D.lib zdll.lib zziplibd.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib glew32.lib zziplib.lib RTScene.lib RTWorld.lib cg.lib cgGL.lib QtInterface05.lib QtGuid4.lib QtOpenGLd4.lib QtCored4.lib qtmain.lib Preprocessor05.lib"
+				OutputFile="../bin/$(ConfigurationName)/Preprocessor.exe"
 				LinkIncremental="2"
-				AdditionalLibraryDirectories="..\include;..\src\GL;&quot;..\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib"
+				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\src\GL;&quot;..\lib05\$(ConfigurationName)&quot;;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;&quot;..\MultiLevelRayTracing\RTScene\$(ConfigurationName)&quot;;&quot;..\MultiLevelRayTracing\RTWorld\$(ConfigurationName)&quot;;&quot;QtInterface\$(ConfigurationName)&quot;;&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces-c_2_8_0\lib&quot;;&quot;$(CG_LIB_PATH)&quot;"
 				GenerateDebugInformation="true"
 				ProgramDatabaseFile="$(OutDir)/TestPreprocessor.pdb"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2679)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2680)
@@ -235,5 +235,4 @@
 	{
 		cerr << "error: view cells could not be loaded" << endl;
-
 		Cleanup();
 		exit(1);
@@ -261,5 +260,5 @@
 			cout << "successfully loaded " << viewCellPointsFile << endl;
 		else
-			cout << "error: file << " << viewCellPointsFile << " not found, generating random view points!" << endl;
+			cerr << "error: file << " << viewCellPointsFile << " not found, generating random view points!" << endl;
 	}
 
@@ -293,7 +292,4 @@
 	// create a qt application first (must be created before any opengl widget ...)
 	QApplication *app = new QApplication(argc, NULL);
-
-	//Dummy dummy(1024, 1024);
-	//dummy.dummyBuffer();
 
 	pt = new QtPreprocessorThread(preprocessor);	
@@ -326,6 +322,4 @@
 
 		preprocessor->renderer = glbuf;
-			
-		//glbuf->dummyBuffer();
 	}
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp	(revision 2610)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp	(revision 2680)
@@ -151,5 +151,5 @@
 		cout<<"Evaluating render error"<<endl;
 		ComputeRenderError();
-		cout<<"Evaluating render error"<<endl;
+		cout<<"finished evaluating error"<<endl;
 	  }
 	}