Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh	(revision 2679)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vps.sh	(revision 2682)
@@ -11,6 +11,6 @@
 echo "starting $TARGET version"
 
-#SCENE=../data/vienna/vienna_cropped.obj
-SCENE=../data/vienna/city_full.obj
+SCENE=../data/vienna/vienna_cropped.obj
+#SCENE=../data/vienna/city_full.obj
 
 VIEWCELLS=../data/vienna/vienna_cropped-gradient-viewcells.xml.gz 
Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/gvs.env
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/gvs.env	(revision 2677)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/gvs.env	(revision 2682)
@@ -35,6 +35,6 @@
 	loadMeshes false
 
-	# internal: 0 intel: 1
-	rayCastMethod 1
+	# internal: 0 intel: 1 2: havran 3: havran dyn
+	rayCastMethod 2
 
 	exportVisibility false
Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_vienna
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_vienna	(revision 2677)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_demo_vienna	(revision 2682)
@@ -8,6 +8,6 @@
 
 
-#SCENE=../data/vienna/vienna_cropped.obj
-SCENE=../data/vienna/city_full.obj
+SCENE=../data/vienna/vienna_cropped.obj
+#SCENE=../data/vienna/city_full.obj
 
 VIEWCELLS=../data/vienna/vienna_cropped-seq-3000-false-20-viewcells.xml.gz
Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vienna.sh
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vienna.sh	(revision 2677)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/run_gvs_vienna.sh	(revision 2682)
@@ -13,6 +13,6 @@
 echo "starting $TARGET version"
 
-#SCENE=../data/vienna/vienna_cropped.obj
-SCENE=../data/vienna/city_full.obj
+SCENE=../data/vienna/vienna_cropped.obj
+#SCENE=../data/vienna/city_full.obj
 
 #VIEWCELLS=../data/vienna/vienna_cropped-57000-viewcells.xml.gz
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2680)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2682)
@@ -1658,26 +1658,9 @@
 bool Preprocessor::LoadDynamicGeometry(const string &filename)
 {
+#if DYNAMIC_OBJECTS_HACK
+
 	const bool dynamic = true;
-#if DYNAMIC_OBJECTS_HACK
-#if USE_TRANSFORMED_MESH_INSTANCE_HACK
-
-	Mesh *mesh = LoadBinaryObjIntoMesh(filename);
-    
-	if (mesh)
-	{
-		SceneGraphLeaf *leaf = new SceneGraphLeaf(dynamic);
-
-		TransformedMeshInstance *tmi = new TransformedMeshInstance(mesh);
-		leaf->mGeometry.push_back(tmi);
-
-		mSceneGraph->GetRoot()->mChildren.push_back(leaf);
-
-		mDynamicObjects.push_back(tmi);
-		
-		return true;
-	}
-#else
-
 	SceneGraphLeaf *leaf = new SceneGraphLeaf(dynamic);
+
 	bool parsed = false;
 
@@ -1726,5 +1709,5 @@
 	}
 
-#endif
+
 #endif
 	return false;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2679)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtGlRenderer.cpp	(revision 2682)
@@ -568,5 +568,6 @@
 {
 	EnableDrawArrays();
-	if (mUseVbos)
+
+	if (0) //mUseVbos)
 		glBindBufferARB(GL_ARRAY_BUFFER_ARB, mVboId);
 
@@ -580,5 +581,5 @@
 	glDrawElements(GL_TRIANGLES, mIndexBufferSize, GL_UNSIGNED_INT, mIndices);
 
-#if DYNAMIC_OBJECTS_HACK
+#if 0// DYNAMIC_OBJECTS_HACK
 	// handle dynamic objects
 	DynamicObjectsContainer::const_iterator dit, dit_end = mDynamicObjects.end();
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/HavranDynRayCaster.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/HavranDynRayCaster.cpp	(revision 2655)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/HavranDynRayCaster.cpp	(revision 2682)
@@ -664,13 +664,13 @@
 #ifdef USE_HAVRAN_RAYCASTER
 
-  int hit_triangles[16];
-  float dist[16];
+  //int hit_triangles[16];
+  //float dist[16];
   Vector3 normals[16];
   Vector3 min = sbox.Min();
   Vector3 max = sbox.Max();
   
-  int packets = rays.size() / 16;
-  
-  int i, j, k = 0;
+  int packets = (int)rays.size() / 16;
+  
+  int i, k = 0;
   Vector3 dir;
   
@@ -724,5 +724,5 @@
   int k2 = k;
   for (; k < rays.size(); k++, i++) {
-    double normal[3];
+    //double normal[3];
     // Intersect with the static scene
     bool result = mKtbtree->FindNearestI(rays[k]);
@@ -774,5 +774,5 @@
 			       const bool pruneInvalidRays )
 {
-  int buckets = rays.size()/16;
+  int buckets = (int)rays.size()/16;
   int offset = 0;
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/havran/testrt.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/havran/testrt.cpp	(revision 2656)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/havran/testrt.cpp	(revision 2682)
@@ -1170,5 +1170,5 @@
 	float ox, oy, oz, dx, dy, dz;
 	int hitA; float hitAT;
-	int hitB; float hitBT;	
+	//int hitB; float hitBT;	
 	if (fscanf(fp, "%d %f %f %f %f %f %f %d %f\n",
 		   &order, &ox, &oy, &oz, &dx, &dy, &dz,